;file lib_constants.inc

;*****************************************************************************************
; Data Locations
;*****************************************************************************************
ifdef DEV_48
global_org	=	$0A
bank0_org	=	$00
bank1_org	=	$10
bank2_org	=	$20
bank3_org	=	$30
bank4_org	=	$40
bank5_org	=	$50
bank6_org	=	$60
bank7_org	=	$70
bank8_org	=	$80
bank9_org	=	$90
bank10_org	=	$A0
bank11_org	=	$B0
bank12_org	=	$C0
bank13_org	=	$D0
bank14_org	=	$E0
bank15_org	=	$F0
else
global_org	=	$08
bank0_org	=	$10
bank1_org	=	$30
bank2_org	=	$50
bank3_org	=	$70
bank4_org	=	$90
bank5_org	=	$B0
bank6_org	=	$D0
bank7_org	=	$F0
endif

;*****************************************************************************************
; Code Locations
;*****************************************************************************************
page0_org	equ	$0
page1_org	equ	$200
page2_org	equ	$400
page3_org	equ	$600
ifdef DEV_48
page4_org	equ	$800
page5_org	equ	$A00
page6_org	equ	$C00
page7_org	equ	$E00
endif

code_page0_low	=	$0
code_page0_high	=	$200
code_page1_low	=	$200
code_page1_high	=	$400
code_page2_low	=	$400
code_page2_high	=	$600
code_page3_low	=	$600
ifdef DEV_48
code_page3_high	=	$800
else
code_page3_high	=	$7FF
endif
ifdef DEV_48
code_page4_low	=	$800
code_page4_high	=	$A00
code_page5_low	=	$A00
code_page5_high	=	$C00
code_page6_low	=	$C00
code_page6_high	=	$E00
code_page7_low	=	$E00
code_page7_high	=	$FFF
endif

;*****************************************************************************************
; Port pins
;*****************************************************************************************
NO_PIN		equ	0x00

PORTPIN_RA0	equ	0xA0
PORTPIN_RA1	equ	0xA1
PORTPIN_RA2	equ	0xA2
PORTPIN_RA3	equ	0xA3
PORTPIN_RA4	equ	0xA4
PORTPIN_RA5	equ	0xA5
PORTPIN_RA6	equ	0xA6
PORTPIN_RA7	equ	0xA7

PORTPIN_RB0	equ	0xB0
PORTPIN_RB1	equ	0xB1
PORTPIN_RB2	equ	0xB2
PORTPIN_RB3	equ	0xB3
PORTPIN_RB4	equ	0xB4
PORTPIN_RB5	equ	0xB5
PORTPIN_RB6	equ	0xB6
PORTPIN_RB7	equ	0xB7

ifndef DEV_18
PORTPIN_RC0	equ	0xC0
PORTPIN_RC1	equ	0xC1
PORTPIN_RC2	equ	0xC2
PORTPIN_RC3	equ	0xC3
PORTPIN_RC4	equ	0xC4
PORTPIN_RC5	equ	0xC5
PORTPIN_RC6	equ	0xC6
PORTPIN_RC7	equ	0xC7
endif

ifdef DEV_48
PORTPIN_RD0	equ	0xD0
PORTPIN_RD1	equ	0xD1
PORTPIN_RD2	equ	0xD2
PORTPIN_RD3	equ	0xD3
PORTPIN_RD4	equ	0xD4
PORTPIN_RD5	equ	0xD5
PORTPIN_RD6	equ	0xD6
PORTPIN_RD7	equ	0xD7

PORTPIN_RE0	equ	0xE0
PORTPIN_RE1	equ	0xE1
PORTPIN_RE2	equ	0xE2
PORTPIN_RE3	equ	0xE3
PORTPIN_RE4	equ	0xE4
PORTPIN_RE5	equ	0xE5
PORTPIN_RE6	equ	0xE6
PORTPIN_RE7	equ	0xE7
endif

;*****************************************************************************************
; Power up register values
;*****************************************************************************************

RA_tris_PU	equ	%11111111	;port A direction register 1=input 0=output
RA_plp_PU	equ	%11111111	;port A pull up register 1=off 0=on
RA_lvl_PU	equ	%11111111	;port A level register 1=ttl 0=cmos

RB_tris_PU	equ	%11111111	;port B direction register 1=input 0=output
RB_plp_PU	equ	%11111111	;port B pull up register 1=off 0=on
RB_lvl_PU	equ	%11111111	;port B level register 1=ttl 0=cmos
RB_st_PU	equ	%11111111	;port B schmitt trigger register 1=off 0=on
RB_wken_PU	equ	%11111111	;port B wake up enable register 1=off 0=on
RB_wked_PU	equ	%11111111	;port B wake up edge register 1=neg 0=pos
RB_wkpnd_PU	equ	%11111111	;port B MIWI pending register 1=detected 0=not detected
RB_cmp_PU	equ	%11111111	;port B comparator enable register 1=disabled 0=enabled

RC_tris_PU	equ	%11111111	;port C direction register 1=input 0=output
RC_plp_PU	equ	%11111111	;port C pull up register 1=off 0=on
RC_lvl_PU	equ	%11111111	;port C level register 1=ttl 0=cmos
RC_st_PU	equ	%11111111	;port C schmitt trigger register 1=off 0=on

RD_tris_PU	equ	%11111111	;port D direction register 1=input 0=output
RD_plp_PU	equ	%11111111	;port D pull up register 1=off 0=on
RD_lvl_PU	equ	%11111111	;port D level register 1=ttl 0=cmos
RD_st_PU	equ	%11111111	;port D schmitt trigger register 1=off 0=on

RE_tris_PU	equ	%11111111	;port E direction register 1=input 0=output
RE_plp_PU	equ	%11111111	;port E pull up register 1=off 0=on
RE_lvl_PU	equ	%11111111	;port E level register 1=ttl 0=cmos
RE_st_PU	equ	%11111111	;port E schmitt trigger register 1=off 0=on

portA_dirbuf	equ	$FA		;copy of port A direction register
portB_dirbuf	equ	$FB		;copy of port B direction register
portC_dirbuf	equ	$FC		;copy of port C direction register
portD_dirbuf	equ	$FD		;copy of port D direction register
portE_dirbuf	equ	$FE		;copy of port E direction register

;*****************************************************************************************
; Mode register values
;*****************************************************************************************
M_CMP			equ	$08
M_WKPND			equ	$09
M_WKED			equ	$0A
M_WKEN			equ	$0B
M_ST			equ	$0C
M_LVL			equ	$0D
M_PLP			equ	$0E
M_TRIS			equ	$0F

;*****************************************************************************************
; Option register values
;*****************************************************************************************
RTCC_ON			equ	%10000000	;Enables RTCC at address $01 (RTW hi)
						;*WREG at address $01 (RTW lo) by default
RTCC_ID			equ	%01000000	;Disables RTCC edge interrupt (RTE_IE hi)
						;*RTCC edge interrupt (RTE_IE lo) enabled by default
RTCC_INC_EXT		equ	%00100000	;Sets RTCC increment on RTCC pin transition (RTS hi)
						;*RTCC increment on internal instruction (RTS lo) is defalut
RTCC_FE			equ	%00010000	;Sets RTCC to increment on falling edge (RTE_ES hi)
						;*RTCC to increment on rising edge (RTE_ES lo) is default
RTCC_PS_ON		equ	%00000000	;Assigns prescaler to RTCC (PSA lo)
RTCC_PS_OFF		equ	%00001000	;Assigns prescaler to WDT (PSA hi)
RTCC_PS_000		equ	%00000000	;RTCC = 1:2, WDT = 1:1
RTCC_PS_001		equ	%00000001	;RTCC = 1:4, WDT = 1:2
RTCC_PS_010		equ	%00000010	;RTCC = 1:8, WDT = 1:4
RTCC_PS_011		equ	%00000011	;RTCC = 1:16, WDT = 1:8
RTCC_PS_100		equ	%00000100	;RTCC = 1:32, WDT = 1:16
RTCC_PS_101		equ	%00000101	;RTCC = 1:64, WDT = 1:32
RTCC_PS_110		equ	%00000110	;RTCC = 1:128, WDT = 1:64
RTCC_PS_111		equ	%00000111	;RTCC = 1:256, WDT = 1:128

;-----------------------------------------------------------------------------------------

			; secret instruction fifo
fifo			macro
			dw	$47
endm

			; secret instruction pushW
pushW			macro
			dw	$48
endm

			; secret instruction pushST
pushST			macro
			dw	$49
endm

			; secret instruction pushFSR
pushFSR			macro
			dw	$4A
endm

			; secret instruction pushPC
pushPC			macro
			dw	$4B
endm

			; secret instruction popW
popW			macro
			dw	$4C
endm

			; secret instruction popST
popST			macro
			dw	$4D
endm

			; secret instruction popFSR
popFSR			macro
			dw	$4E
endm

			; secret instruction popPC
popPC			macro
			dw	$4F
endm

	;*********************************************************************************
	; Macro: _bank
	; Sets the bank appropriately for all revisions of SX.
	;
	; This is required since the bank instruction has only a 3-bit operand, it cannot
	; be used to access all 16 banks of the SX48/52. For this reason FSR.4 (for SX48/52BD/ES)
	; or FSR.7 (SX48/52bd production release) needs to be set appropriately, depending
	; on the bank address being accessed. This macro fixes this.
	;
	; So, instead of using the bank instruction to switch between banks, use _bank instead.
	; 
	;*********************************************************************************
_bank	macro	1
	bank	\1
	ifdef DEV48
		if \1 & %10000000		;SX48BD and SX52BD (production release) bank instruction 
			setb	fsr.7		;modifies FSR bits 4,5 and 6. FSR.7 needs to be set by software.
		else
			clrb	fsr.7
		endif
	endif
	endm

;-----------------------------------------------------------------------------------------

;end of file lib_constants.inc
