noexpand
;file lib_main.inc

include "lib_constants.inc"
include "lib_uartCalculations.inc"
include "lib_threads.inc"
include "lib_initPorts.inc"
include "lib_dirbuf.inc"
include "lib_timer8.inc"
include "lib_timer16.inc"
include "lib_queue.inc"
include "lib_stack.inc"
include "lib_parity.inc"
include "lib_uartTransmit.inc"
include "lib_uartReceive.inc"
include "lib_i2cMaster.inc"
include "lib_i2cSlave.inc"

;*****************************************************************************************
; Autoplacement macros
;*****************************************************************************************	

lowcodeloc = 0
highcodeloc = 0

_lib_install_test	macro	loworg, highorg, lowhalfsize, highhalfsize
lowcodeloc = loworg
  if lowcodeloc + lowhalfsize > (lowcodeloc & $E00) + $100
    lowcodeloc = 0
    highcodeloc = 0
  else
highcodeloc = highorg
    if highcodeloc - highhalfsize < lowcodeloc + lowhalfsize
      lowcodeloc = 0
      highcodeloc = 0
    endif
  endif
endm

_lib_install_vpcode	macro	lowhalfname, lowhalfsize, highhalfname, highhalfsize
_lib_install_test code_page1_low, code_page1_high, lowhalfsize, highhalfsize
if ((lowcodeloc | highcodeloc) != 0)
expand
		org	lowcodeloc
noexpand
code		=	$
lowhalfname
code_page1_low	=	code
expand
		org	highcodeloc-highhalfsize
noexpand
code		=	$
code_page1_high	=	code
highhalfname
else
  _lib_install_test code_page2_low, code_page2_high, lowhalfsize, highhalfsize
  if ((lowcodeloc | highcodeloc) != 0)
expand
		org	lowcodeloc
noexpand
code		=	$
lowhalfname
code_page2_low	=	code
expand
		org	highcodeloc-highhalfsize
noexpand
code		=	$
code_page2_high	=	code
highhalfname
  else
    _lib_install_test code_page3_low, code_page3_high, lowhalfsize, highhalfsize
    if ((lowcodeloc | highcodeloc) != 0)
expand
		org	lowcodeloc
noexpand
code		=	$
lowhalfname
code_page3_low	=	code
expand
		org	highcodeloc-highhalfsize
noexpand
code		=	$
code_page3_high	=	code
highhalfname
    else
ifdef DEV_48
      _lib_install_test code_page4_low, code_page4_high, lowhalfsize, highhalfsize
      if ((lowcodeloc | highcodeloc) != 0)
expand
		org	lowcodeloc
noexpand
code		=	$
lowhalfname
code_page4_low	=	code
expand
		org	highcodeloc-highhalfsize
noexpand
code		=	$
code_page4_high	=	code
highhalfname
      else
        _lib_install_test code_page5_low, code_page5_high, lowhalfsize, highhalfsize
        if ((lowcodeloc | highcodeloc) != 0)
expand
		org	lowcodeloc
noexpand
code		=	$
lowhalfname
code_page5_low	=	code
expand
		org	highcodeloc-highhalfsize
noexpand
code		=	$
code_page5_high	=	code
highhalfname
        else
          _lib_install_test code_page6_low, code_page6_high, lowhalfsize, highhalfsize
          if ((lowcodeloc | highcodeloc) != 0)
expand
		org	lowcodeloc
noexpand
code		=	$
lowhalfname
code_page6_low	=	code
expand
		org	highcodeloc-highhalfsize
noexpand
code		=	$
code_page6_high	=	code
highhalfname
          else
            _lib_install_test code_page7_low, code_page7_high, lowhalfsize, highhalfsize
            if ((lowcodeloc | highcodeloc) != 0)
expand
		org	lowcodeloc
noexpand
code		=	$
lowhalfname
code_page7_low	=	code
expand
		org	highcodeloc-highhalfsize
noexpand
code		=	$
code_page7_high	=	code
highhalfname
            else
              error "Not enough space to install code"
            endif
          endif
        endif
      endif
else
  error "Not enough space to install code"
endif
    endif
  endif
endif
endm

lib_install	macro
ifdef vp_i2cSlave
  _lib_install_vpcode _lib_i2cSlave_lowhalf, _lib_i2cSlave_lowsize, _lib_i2cSlave_highhalf, _lib_i2cSlave_highsize
endif
ifdef vp_i2cMaster
  _lib_install_vpcode _lib_i2cMaster_lowhalf, _lib_i2cMaster_lowsize, _lib_i2cMaster_highhalf, _lib_i2cMaster_highsize
endif
ifdef vp_uartReceive
  _lib_install_vpcode _lib_uartReceive_lowhalf, _lib_uartReceive_lowsize, _lib_uartReceive_highhalf, _lib_uartReceive_highsize
endif
ifdef vp_uartTransmit
  _lib_install_vpcode _lib_uartTransmit_lowhalf, _lib_uartTransmit_lowsize, _lib_uartTransmit_highhalf, _lib_uartTransmit_highsize
endif
ifdef vp_dirbuf
  _lib_install_vpcode _lib_dirbuf_lowhalf, _lib_dirbuf_lowsize, _lib_dirbuf_highhalf, _lib_dirbuf_highsize
endif
ifdef vp_parity
  _lib_install_vpcode _lib_parity_lowhalf, _lib_parity_lowsize, _lib_parity_highhalf, _lib_parity_highsize
endif
ifdef vp_queue
  _lib_install_vpcode _lib_queue_lowhalf, _lib_queue_lowsize, _lib_queue_highhalf, _lib_queue_highsize
endif
ifdef vp_stack
  _lib_install_vpcode _lib_stack_lowhalf, _lib_stack_lowsize, _lib_stack_highhalf, _lib_stack_highsize
endif
ifdef vp_timer16
  _lib_install_vpcode _lib_timer16_lowhalf, _lib_timer16_lowsize, _lib_timer16_highhalf, _lib_timer16_highsize
endif
ifdef vp_timer8
  _lib_install_vpcode _lib_timer8_lowhalf, _lib_timer8_lowsize, _lib_timer8_highhalf, _lib_timer8_highsize
endif
endm

;end of file lib_main.inc
