;file lib_queue.inc

;queue buffer layout
;
; +----+----+
; |size| num|  size = number of databytes in queue buffer, num = number of values in queue 
; +----+----+
; |head|tail|  head = position last stored value, tail = position before value to retrieve
; +----+----+
; | d a t a |
; | d a t a |

_lib_queue_var		macro	name, size
  tempsize = size+2
if ((data + tempsize - 1) & $F0) != (data & $F0)
error "queue buffer too large, crossing rambank boundary"
endif
ifndef vp_queue
vp_queue
endif
			org	data
expand
??name??		equ	$
queue_??name??_sizenum	ds	1
queue_??name??_headtail	ds	1
queue_??name??_buffer	ds	size
noexpand
data		=	$
endm

lib_queue	macro	name, size
_lib_queue_var name,size
endm

_lib_queue_lowsize	equ	$002
_lib_queue_lowhalf	macro
		org	code
	begin	=	$
expand
enqueue		jmp	_enqueue
dequeue		jmp	_dequeue
noexpand
code		=	$
if _lib_queue_lowsize > code - begin
  error P2W "_queue_lowsize too large"
endif
if _lib_queue_lowsize < code - begin
  error "_queue_lowsize too small"
endif
endm

_lib_queue_highsize	equ	$02B
_lib_queue_highhalf	macro
		org	code
	begin	=	$
expand
	;enqueue value
	;entry: value in main_temp
	;       fsr set to queue_var address
	;return: Z if queue full (and value not stored)
	;	 fsr destroyed
_enqueue
		mov	w,<>indf	;load size+num
		xor	w,indf		;xor size with num
		snz
		retp			;queue full
		inc	indf		;inc num
		inc	fsr
		add	indf,#$10	;inc head
		dec	fsr
		mov	w,indf		;get size
		inc	fsr
		xor	w,indf		;xor size with head
		and	w,#$F0
		mov	w,#$0F
		snz			;head == size?
		and	indf,w		;yes, clear head
		mov	w,<>indf	;get head in lownib
		and	w,#$0F
		inc	fsr		;point to queue begin
		add	fsr,w		;head position
		mov	w,main_temp
		mov	indf,w		;store value
		retp
	;dequeue value
	;entry: fsr set to queue address
	;return: Z if queue empty (and no value returned)
	;        value in w
_dequeue
		mov	w,indf		;load size+num
		and	w,#$0F		;test num
		snz
		retp			;queue empty
		dec	indf		;dec num
		mov	w,<>indf	;get size in lownib
		inc	fsr
		inc	indf		;inc tail
		xor	w,indf		;xor size with tail
		and	w,#$0F
		mov	w,#$F0
		snz			;tail == size?
		and	indf,w		;yes, clear tail
		mov	w,indf		;get tail in lownib
		and	w,#$0F
		inc	fsr		;point to queue begin
		add	fsr,w		;tail position
		mov	w,indf		;get value
		mov	main_temp,w
		retp
noexpand
code		=	$
if _lib_queue_highsize > code - begin
  error P2W "_queue_highsize too large"
endif
if _lib_queue_highsize < code - begin
  error "_queue_highsize too small"
endif
endm

;end of file lib_queue.inc
