;file lib_timer16.inc

_lib_timer16_var	macro	nr, prefix
			org	data
expand
vp??nr??_bank		equ	($ & $F8)|nr
lib_timer16_setL	=	$+0		;set value
lib_timer16_setH	=	$+1
lib_timer16_countL	=	$+2		;counter
lib_timer16_countH	=	$+3
prefix??_??bank		equ	($ & $F0) | nr
prefix??_??setL		ds	1		;set value
prefix??_??setH		ds	1
prefix??_??countL	ds	1		;counter
prefix??_??countH	ds	1
noexpand
data			=	$
endm

lib_timer16		macro	nr, prefix, timeout, thread
if nr >= maxvp
  error "vp number too high"
endif
ifndef vp_timer16
vp_timer16
endif
vp??nr??_thread	= thread
_lib_timer16_var nr,prefix
			org	code
expand
vp??nr??_init
		mov	lib_timer16_setL,#(timeout&255)
		mov	lib_timer16_setH,#(timeout>>8)
noexpand
code			=	$
expand
		org	vp??nr??_isr
		jmp	@timer16_isr
noexpand
endm

_lib_timer16_lowsize	equ	$001
_lib_timer16_lowhalf	macro
			org	code
	begin	=	$
expand
timer16_isr		jmp	_timer16_isr
noexpand
code		=	$
if _lib_timer16_lowsize > code - begin
  error P2W "_timer16_lowsize too large"
endif
if _lib_timer16_lowsize < code - begin
  error "_timer16_lowsize too small"
endif
endm

_lib_timer16_highsize	equ	$009
_lib_timer16_highhalf	macro
			org	code
	begin		=	$
expand
_timer16_isr
			dec	lib_timer16_countL
			jnz	:timer16_isr_end
			mov	w,lib_timer16_setL
			mov	lib_timer16_countL,w
			mov	w,fsr			;isr_flag to use in lownib
			call	pin_mask
			or	vp_flags,w
:timer16_isr_end
			retp
noexpand
code			=	$
if _lib_timer16_highsize > code - begin
  error P2W "_timer16_highsize too large"
endif
if _lib_timer16_highsize < code - begin
  error "_timer16_highsize too small"
endif
endm

;end of file lib_timer16.inc
