;file lib_timer8.inc

_lib_timer8_var		macro	nr, prefix
			org	data
expand
vp??nr??_bank		equ	($ & $F8)|nr
timer8_set		=	$+0		;set value
timer8_count		=	$+1		;counter
prefix??_??bank		equ	($ & $F0) | nr
prefix??_??set		ds	1		;set value
prefix??_??count	ds	1		;counter
noexpand
data			=	$
endm

lib_timer8		macro	nr, prefix, timeout, thread
if nr >= maxvp
  error "vp number too high"
endif
ifndef vp_timer8
vp_timer8
endif
vp??nr??_thread	= thread
_lib_timer8_var nr,prefix
			org	code
expand
vp??nr??_init
		mov	timer8_set,#timeout
noexpand
code			=	$
expand
		org	vp??nr??_isr
		jmp	@timer8_isr
noexpand
endm

_lib_timer8_lowsize	equ	$001
_lib_timer8_lowhalf		macro
			org	code
	begin	=	$
expand
timer8_isr		jmp	_timer8_isr
noexpand
code		=	$
if _lib_timer8_lowsize > code - begin
  error P2W "_timer8_lowsize too large"
endif
if _lib_timer8_lowsize < code - begin
  error "_timer8_lowsize too small"
endif
endm

_lib_timer8_highsize	equ	$009
_lib_timer8_highhalf	macro
			org	code
	begin	=	$
expand
_timer8_isr
			dec	timer8_count
			jnz	:timer8_isr_end
			mov	w,timer8_set
			mov	timer8_count,w
			mov	w,fsr			;isr_flag to use in lownib
			call	pin_mask
			or	vp_flags,w
:timer8_isr_end
			retp
noexpand
code			=	$
if _lib_timer8_highsize > code - begin
  error P2W "_timer8_highsize too large"
endif
if _lib_timer8_highsize < code - begin
  error "_timer8_highsize too small"
endif
endm

;end of file lib_timer8.inc
